#!/usr/bin/wish
#
#    cont2d - contour line generator 
#
#    Ver.1.0 Thu May 11 22:40:11 JST 2000
#    Copyright Amane Tanaka (amane@bd5.so-net.ne.jp)
#
#    Thes GUI program calls:
#        ngraph, contchk, cont2dc, cont2df and cont2dm.

proc mainwindow {} {
    global ifile is nx ny cx cy cz msk end ofile resx resy
    global zmin zmax na dz ng ratio
    global .t0 file n sw coml .l_num

    label .l_input -text "cont2d - contour line generator"
    label .l_ifile -text "Input Data :"
    entry .e_ifile -textvariable ifile
    label .l_is -text "Skip lines :"
    entry .e_is -textvariable is -width 5
    label .l_nn -text "Number of Data :"
    label .l_nx -text " nx:"
    entry .e_nx -textvariable nx -width 5
    label .l_ny -text " ny:"
    entry .e_ny -textvariable ny -width 5
    label .l_column -text "Data Column :"
    entry .e_cx -textvariable cx -width 5
    entry .e_cy -textvariable cy -width 5
    entry .e_cz -textvariable cz -width 5
    entry .e_msk -textvariable msk -width 5
    entry .e_end -textvariable end -width 5
    label .l_cx -text "x col"
    label .l_cy -text "y col"
    label .l_cz -text "z col"
    label .l_msk -text "mask"
    label .l_end -text "end col"
    button .b_ifile -text "browse" -command {
	set a [tk_getOpenFile]
	if {$a != ""} { set ifile $a }
    } 
    grid .l_input -column 0 -row 0 -sticky {} -columnspan 7
    grid .l_ifile -column 0 -row 1 -sticky e -columnspan 2
    grid .e_ifile -column 2 -row 1 -columnspan 5 -sticky ew -pad 5
    grid .b_ifile -column 7 -row 1 
    grid .l_is -column 0 -row 2 -sticky e -columnspan 2
    grid .e_is -column 2 -row 2 		
    grid .l_nn -column 0 -row 3  -sticky e -columnspan 2
    grid .l_nx -column 2 -row 3 
    grid .e_nx -column 3 -row 3
    grid .l_ny -column 4 -row 3
    grid .e_ny -column 5 -row 3
    grid .l_cx -column 2 -row 4
    grid .l_cy -column 3 -row 4
    grid .l_cz -column 4 -row 4
    grid .l_msk -column 5 -row 4
    grid .l_end -column 6 -row 4 -sticky w
    grid .l_column -column 0 -row 5 -sticky e -columnspan 2
    grid .e_cx -column 2 -row 5 -pad 5
    grid .e_cy -column 3 -row 5 -pad 5
    grid .e_cz -column 4 -row 5 -pad 5
    grid .e_msk -column 5 -row 5 -pad 5
    grid .e_end -column 6 -row 5 -pad 5 -sticky w

    label .l_ofile -text "Output File :"
    entry .e_ofile -textvariable ofile
    button .b_ofile -text "browse" -command {
	set a [tk_getSaveFile]
	if {$a != ""} { set ofile $a }
    } 
    label .l_a -text "Arithmetric sequencial levels" -height 1
    label .l_zmin -text "zmin" -height 1
    label .l_dz -text "dz(>0)" -height 1
    label .l_na -text "n" -height 1
    label .l_g -text "Geometric sequencial levels"
    entry .e_zmin -textvariable zmin -width 12
    entry .e_dz -textvariable dz -width 12
    entry .e_na -textvariable na -width 5
    label .l_zmax -text "zmax"
    label .l_ratio -text "ratio(0<ratio<1)"
    label .l_ng -text "n"
    entry .e_zmax -textvariable zmax -width 12
    entry .e_ratio -textvariable ratio -width 12
    entry .e_ng -textvariable ng -width 5

    button .b_chk -text "auto" -width 11 -command {
	chk
    }
    button .b_seta -text "set" -width 3 -command seta
    button .b_setg -text "set" -width 3 -command setg

    button .b_exit -text "exit" -command "exit" -width 11
    button .b_ngraph -text "ngraph" -command ngraph -width 11

    button .b_2dc -text "cont2dc" -width 11 -command cont2dc
    button .b_2dm -text "cont2dm" -width 11 -command cont2dm
    button .b_2df -text "cont2df" -width 11 -command cont2df
    label .l_2dc -text "Color"
    label .l_2dm -text "Mono"
    label .l_2df -text "Fill"

    .l_num configure -text "Num.of levels: $n"
    .t0 configure -width 12 -height 17
    
    grid .l_ofile -column 0 -row 6 -sticky ne -columnspan 2
    grid .e_ofile -column 2 -row 6 -columnspan 5 -sticky ew -pad 5
    grid .b_ofile -column 7 -row 6
    grid .l_num -column 4 -row 7 -columnspan 3 -sticky e
    grid .l_a -column 0 -row 7 -columnspan 4
    grid .l_zmin -column 0 -row 8
    grid .l_dz -column 2 -row 8
    grid .l_na -column 4 -row 8
    grid .e_zmin -column 0 -row 9 -columnspan 2
    grid .e_dz -column 2 -row 9 -columnspan 2
    grid .e_na -column 4 -row 9
    grid .l_g -column 0 -row 10 -columnspan 4
    grid .l_zmax -column 0 -row 11
    grid .l_ratio -column 2 -row 11 -columnspan 2
    grid .l_ng -column 4 -row 11
    grid .e_zmax -column 0 -row 12 -columnspan 2
    grid .e_ratio -column 2 -row 12 -columnspan 2
    grid .e_ng -column 4 -row 12
    grid .t0 -column 6 -row 8 -columnspan 2 -rowspan 15 -pad 5
    grid .b_chk -column 0 -row 13 -columnspan 2
    grid .b_seta -column 5 -row 9
    grid .b_setg -column 5 -row 12
    grid .l_2dc -column 0 -row 15 -columnspan 2
    grid .l_2dm -column 2 -row 15 -columnspan 2
    grid .l_2df -column 4 -row 15 -columnspan 2
    grid .b_2dc -column 0 -row 16 -columnspan 2
    grid .b_2dm -column 2 -row 16 -columnspan 2
    grid .b_2df -column 4 -row 16 -columnspan 2
    grid .b_exit -column 0 -row 18 -columnspan 2
    grid .b_ngraph -column 0 -row 17 -columnspan 2

    label .l_res -text "Resolution for Fill"
    label .l_resx -text "ires:"
    label .l_resy -text "jres:"
    entry .e_resx -textvariable resx -width 5
    entry .e_resy -textvariable resy -width 5
    grid .l_res -column 0 -row 14 -columnspan 2
    grid .l_resx -column 2 -row 14
    grid .e_resx -column 3 -row 14
    grid .l_resy -column 4 -row 14
    grid .e_resy -column 5 -row 14

    checkbutton .c0 -text "data" -variable cdata
    checkbutton .c1 -text "grid" -variable cgrid
    checkbutton .c2 -text "frame" -variable cframe
    grid .c0 -column 2 -row 17
    grid .c1 -column 3 -row 17
    grid .c2 -column 4 -row 17
}

proc chk {} {
    global ifile is nx ny cx cy cz msk end
    global zmin zmax na nb dz ratio 
    set inp "contchk.inp" 
    set f [ open $inp w ]
    puts $f "$ifile"
    set is [format "%4i" $is]
    set nx [format "%4i" $nx]
    set ny [format "%4i" $ny]
    set cx [format "%4i" $cx]
    set cy [format "%4i" $cy]
    set cz [format "%4i" $cz]
    set msk [format "%4i" $msk]
    set end [format "%4i" $end]
    puts $f "$is"
    puts $f "$nx $ny"
    puts $f "$cx $cy $cz $msk $end"
    close $f
    exec contchk <contchk.inp >contchk.dat
    set dat "contchk.dat"
    set f [ open $dat r ]
    gets $f l 
    gets $f l 
    gets $f l 
    gets $f l 
    gets $f l 
    split l " " 
    set zmin [lindex $l 2]
    set zmax [lindex $l 5]
    close $f
    set dz [expr ($zmax-$zmin)/($na-1)]
    set ratio 0.5
    if { $zmin >= 0 } {
	set a [expr log($zmin)-log($zmax)]
	set b [expr $a/($ng-1)]
	if { $b < 700 } { 
	    if { $b > -700 } {
	    set ratio [expr exp($b)]
	    }
	}
    }
    formf
}

proc cont2dc {} {
    formf
    savef
    exec cont2dc < cont2d.inp
}	

proc cont2dm {} {
    formf
    savef
    exec cont2dm < cont2d.inp
}	

proc cont2df {} {
    formf
    savef
    exec cont2df < cont2d.inp
}	

proc loadf {} {
    global .t0 n
    global ifile is nx ny cx cy cz msk end ofile resx resy
    set file "cont2d.inp"
    .t0 delete 1.0 end
    set f [ open $file r ]
    gets $f ifile
    gets $f is
    gets $f line
    split line " "
    set nx [lindex $line 0]
    set ny [lindex $line 1]
    gets $f line
    split line " "
    set cx [lindex $line 0]
    set cy [lindex $line 1]
    set cz [lindex $line 2]
    set msk [lindex $line 3]
    set end [lindex $line 4]
    gets $f ofile	
    gets $f n
    for { set i 1 } { $i <= $n } { incr i } {
	gets $f line
	set err [catch {set level [format "%4.5e" $line]}]
	if { $err } { 
	    set n [expr $i-1]
	    break 
	}
	.t0 insert end "$level\n"
    }
    gets $f line
    split line " "
    set resx [lindex $line 0]
    set resy [lindex $line 1]
    close $f
}

proc formf {} {
    global .t0 n .l_num
    global is nx ny cx cy cz msk end resx resy
    global zmin zmax dz ratio na ng
    for { set i 1 } { [.t0 compare $i.0 < end-1chars] } { incr i } {
	set line [.t0 get $i.0 $i.0lineend]
	set line [format "%4.5e" $line]
	.t0 delete $i.0 $i.0lineend
	.t0 insert $i.0 "$line"
    }
    set n [format "%4i" [expr $i-1]]
    .l_num configure -text "Num.of levels $n" 
    set is [format "%4i" $is]
    set nx [format "%4i" $nx]
    set ny [format "%4i" $ny]
    set cx [format "%4i" $cx]
    set cy [format "%4i" $cy]
    set cz [format "%4i" $cz]
    set msk [format "%4i" $msk]
    set end [format "%4i" $end]
    set zmin [format "%4.5e" $zmin]
    set zmax [format "%4.5e" $zmax]
    set dz [format "%4.5e" $dz]
    set ratio [format "%4.5e" $ratio]
    set na [format "%4i" $na]
    set ng [format "%4i" $ng]
    set resx [format "%4i" $resx]
    set resy [format "%4i" $resy]
}

proc savef {} {
    global .t0 n
    global ifile is nx ny cx cy cz msk end ofile resx resy
    set file "cont2d.inp"
    set f [ open $file w ]
    puts $f "$ifile"
    puts $f "$is"
    puts $f "$nx $ny"
    puts $f "$cx $cy $cz $msk $end"
    puts $f "$ofile"	
    puts $f "$n"
    for { set i 1 } { $i <= $n } { incr i } {
	set line [.t0 get $i.0 $i.0lineend]
	puts $f "$line"
    }
    puts $f "$resx $resy"
    close $f
} 

proc seta {} {
    global .t0 n
    global zmin dz na
    set n $na
    .t0 delete 1.0 end
    for { set i 1 } { $i <= $n } { incr i } {
	set level [expr $zmin+$dz*($i-1)]
	.t0 insert end "$level\n"
    }
    formf
}

proc setg {} {
    global .t0 n
    global zmax ratio ng
    set n $ng
    .t0 delete 1.0 end
    set level $zmax
    .t0 insert end "$level\n"
    for { set i 1 } { $i < $n } { incr i } {
	set level [expr $level*$ratio]
	.t0 insert 1.0 "$level\n"
    }
    formf
}

proc ngraph {} {
    global ofile cdata cgrid cframe
    set c 0
    if { $cdata } { incr c }
    if { $cgrid } { incr c }
    if { $cframe } { incr c }
    if { $c > 0 } {
	set dat "${ofile}.ngp"
	set b {"}
	set f [ open $dat w ]
	puts $f {new shell}
	puts $f {shell::shell "_Ngraph.ngp"}
	puts $f {del shell}
	if { $cdata } {
	    set dat1 "${ofile}.part"
	    puts $f {new shell}
	    puts $f "shell::shell ${b}${dat1}${b}"
	    puts $f {del shell}
	}
	if { $cgrid } {
	    set dat1 "${ofile}_grd.part"
	    puts $f {new shell}
	    puts $f "shell::shell ${b}${dat1}${b}"
	    puts $f {del shell}
	}
	if { $cframe } {
	    set dat1 "${ofile}_frm.part"
	    puts $f {new shell}
	    puts $f "shell::shell ${b}${dat1}${b}"
	    puts $f {del shell}
	}
	close $f
	exec ngraph $dat &
    } else {
	exec ngraph &
    }
}


text .t0
label .l_num
set ifile {}
set is 0
set nx 0
set ny 0
set cx 1
set cy 2
set cz 3
set msk 0
set end 3
set ofile "cont"
set n 0
set zmin 0
set zmax 0
set ng 11
set na 11
set dz 0.5
set ratio 0.5
set resx 400
set resy 400

set err [catch loadf]
formf
mainwindow
